module Smtpcom
  module Sendapi
    class ApiResource
      include Request

      def initialize(attrs = {})
        self.class::MAPPINGS.keys.each do |k|
          instance_variable_set("@#{k}", attrs[k]) if attrs.key? k
        end
      end

      def self.build_from_response(data)
        new Hash[self::MAPPINGS.map { |k, v| [k.to_sym, data[v.to_s]] }] if data
      end

      def _get(*attrs)
        self.class._get(*attrs)
      end

      def _get_raw(*attrs)
        self.class._get_raw(*attrs)
      end

      def _post(*attrs)
        self.class._post(*attrs)
      end

      def prepare_params
        Hash[self.class::MAPPINGS.map { |k, v| [v, instance_variable_get("@#{k}")] }]
      end
    end
  end
end
