module Smtpcom
  module Sendapi
    class Campaign < ApiResource
      MAPPINGS = {
        id:         :CampaignID,
        name:       :CampaignName,
        opens:      :Opens,
        clicks:     :Clicks,
        delivered:  :Delivered,
        bounced:    :Bounced
      }

      attr_accessor :id, :name
      attr_reader :opens, :clicks, :delivered, :bounced

      class << self
        def all
          _get('/campaigns/get')['Data'].map do |row|
            build_from_response row
          end
        end

        def find(id)
          all.find { |c| c.id == id }
        end
      end

      def save
        attrs = { CampaignName: @name }
        res = if @id
                _get '/campaigns/update', attrs.merge(CampaignID: @id), :formatted
              else
                _post '/campaigns/add', attrs, :formatted
              end
        @id = res[:id]
        res
      end

      def delete
        _post('/campaigns/delete', { CampaignID: @id }, :formatted)
      end
    end
  end
end
