module Smtpcom
  module Sendapi
    class RealTimeReporting < ApiResource
      MAPPINGS = {
        queue_name:           :QueueName,
        server_region:        :ServerRegion,
        public_access_key:    :PublicAccessKey,
        private_access_key:   :PrivateAccessKey,
        notify_opens:         :NotifyOpens,
        notify_clicks:        :NotifyClicks,
        notify_delivert_info: :NotifyDelivertInfo
      }

      attr_accessor(*MAPPINGS.keys)

      def self.settings
        build_from_response(_get('/realtimereporting/get'))
      end

      def self.build_from_response(data)
        new Hash[MAPPINGS.map { |k, v| [k.to_sym, data["InstantNotification_#{v}"]] }].merge \
          notify_opens:         data['InstantNotification_NotifyOpens'] == 'On',
          notify_clicks:        data['InstantNotification_NotifyClicks'] == 'On',
          notify_delivert_info: data['InstantNotification_NotifyDelivertInfo'] == 'On'
      end

      def save
        _post '/realtimereporting/update', prepare_params, :formatted
      end

      def prepare_params
        super.merge \
          NotifyOpens:        (notify_opens ? 'On' : 'Off'),
          NotifyClicks:       (notify_clicks ? 'On' : 'Off'),
          NotifyDelivertInfo: (notify_delivert_info ? 'On' : 'Off')
      end
    end
  end
end
