module Smtpcom
  module Sendapi
    class StatsSummary < ApiResource
      attr_reader :start, :finish, :sender, :campaign, :total

      def initialize(start, finish, sender = nil, campaign = nil)
        @start    = start
        @finish   = finish
        @sender   = sender
        @campaign = campaign
      end

      def all
        format_response _get('/summarystats/get', prepare_params)
      end

      def csv
        _get_raw('/summarystatsexport/get', prepare_params.merge(headers: { 'Accept' => 'text/csv' }))
      end

      def prepare_params
        attributes = {
          DateFrom: @start.strftime("%m/%d/%Y"),
          DateTo:   @finish.strftime("%m/%d/%Y")
        }
        attributes[:Sender]     = @sender    if @sender
        attributes[:CampaignID] = @campaign  if @campaign
        attributes
      end

      private

      def format_response(data)
        dd = Utils.format_response_row(data)
        dd[:day_stats].map! do |row|
          Utils.format_response_row(row)
        end
        dd
      end
    end
  end
end
