module Smtpcom
  module Sendapi
    class Template < ApiResource
      MAPPINGS = {
        id:         :_id,
        name:       :TemplateName,
        from:       :From,
        from_name:  :FromName,
        subject:    :Subject,
        html:       :Html
      }

      attr_accessor(*MAPPINGS.keys)

      class << self
        def all
          _get('/templates/get')['Data'].map do |row|
            build_from_response row
          end
        end

        def find(id)
          build_from_response _get('/template/get', TemplateID: id)['Data']
        end
      end

      def save
        attrs = {
          TemplateName: @name,
          From:         @from,
          FromName:     @from_name,
          Subject:      @subject,
          Html:         @html
        }
        res = if @id
                _post '/templates/update', attrs.merge(TemplateID: @id), :formatted
              else
                _post '/templates/add', attrs, :formatted
              end
        @id = res[:id]
        res
      end

      def delete
        _post('/templates/delete', { TemplateID: @id }, :formatted)
      end
    end
  end
end
